<?php

namespace Drupal\data_fixtures;

/**
 * A wrapper around a Generator that gives access to some useful information.
 *
 * @package Drupal\data_fixtures
 */
class FixturesGenerator {

  /**
   * The (opional) alias of the Generator.
   *
   * @var string
   */
  private $alias;

  /**
   * The Generator isntance.
   *
   * @var \Drupal\data_fixtures\Interfaces\Generator
   */
  private $generator;

  public function __construct($generator, $alias=null) {
    $this->setGenerator($generator);
    $this->setAlias($alias);
  }

  /**
   * @return string
   */
  public function prettyPrint() {
    return $this->getAlias() . ' :: ' . $this->getClassName();
  }

  /**
   * @return string
   */
  public function getClassName() {
    return get_class($this->generator);
  }

  /**
   * @return string
   */
  public function getAlias() {
    return $this->alias;
  }

  /**
   * @param string $alias
   */
  public function setAlias($alias) {
    if (empty($alias)) {
      $alias = (new \ReflectionClass($this->getGenerator()))->getShortName();
    }

    $this->alias = $alias;
  }

  /**
   * @return \Drupal\data_fixtures\Interfaces\Generator
   */
  public function getGenerator() {
    return $this->generator;
  }

  /**
   * @param \Drupal\data_fixtures\Interfaces\Generator $generator
   */
  public function setGenerator($generator) {
    $this->generator = $generator;
  }
}
